#!/usr/bin/perl
####################################################################################################
# HTML PARSER		 		                        	
# Copyright 2002 Psybercore.com, Inc.						info@superscripts.com                 
####################################################################################################
# COPYRIGHT NOTICE                                                           
# Copyright 2002 Psybercore.com, INC - All Rights Reserved.                    
# http://www.superscripts.com                                                                                                            
# Selling the code for this program, modifying or redistributing this software over the Internet or 
# in any other medium is forbidden.  Copyright and header may not be modified
#
# my name is DREW STAR... and I am funky... http://www.drewstar.com/
#
####################################################################################################



sub parsehtml() {

    ## Get array ref 
    my($file) = shift @_;
    
    ## Set up vars
    my($description, $keywords, $title) = '';

    ## Read contents of array into single string variable, $wholefile, and 
    ## replace \n with null
    foreach (@file) {
	## Get rid of newline
	s/\n//;
	$wholefile .= $_;
    }
    
    ## Get title
    if( $wholefile =~ s/^(.*)<(?:TITLE|title)>(.*)<\/(?:TITLE|title)>(.*)$/$1$3/s) {
	$title = $2;
    }
    
    ## Get meta desc
    if( $wholefile =~ s/^(.*)(?:")?<(?:meta|META)[ ]*(?:NAME|name)[ ]*=(?:")?(?:DESCRIPTION|description)(?:")?[ ]*(?:content|CONTENT)=(?:")?(..*?)(?:")?>(.*)$/$1$3/s) {
	$description = $2;
    }

    ## Get meta keywords
    if( $wholefile =~ s/^(.*)(?:")?<(?:meta|META)[ ]*(?:NAME|name)[ ]*=(?:")?(?:keywords|KEYWORDS)(?:")?[ ]*(?:content|CONTENT)=(?:")?(..*?)(?:")?>(.*)$/$1$3/s) {
	$keywords = $2;
    }

    ## This is the assoc. array of &copy; &quot; etc.
    $subs{'quot'} = "\"";
    $subs{'copy'} = "Copyright";
    $subs{'nbsp'} = " ";
    $subs{'reg'} = "TM";

    ## Replace &copy; etc from %subs
    while($wholefile =~ s/(.*)&([a-z]+);(.*)/$1$subs{$2}$3/) {
	next;
    }

    ## Get rid of remaining HTML tags
    while($wholefile =~ s/^(.*)(?:<.*>)(.*)$/$1 $2/) {
	next;
    }

    return $title, $description, $keywords, $wholefile;
    
}
1;    #  Return true

